"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Tumour(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "tumourId",
        "tumourLocalId",
        "tumourType",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import participant as participant_1_4_0

        return {
            "tumourDiagnosisDate": participant_1_4_0.Date,
            "tumourMorphologies": participant_1_4_0.Morphology,
            "tumourPrimaryTopographies": participant_1_4_0.Topography,
            "tumourTopographies": participant_1_4_0.Topography,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import participant as participant_1_4_0

        return {
            "primaryOrMetastatic": participant_1_4_0.PrimaryOrMetastatic,
            "tumourPresentation": participant_1_4_0.TumourPresentation,
            "tumourType": participant_1_4_0.TumourType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import participant as participant_1_4_0

        return {
            "org.gel.models.participant.avro.PrimaryOrMetastatic": participant_1_4_0.PrimaryOrMetastatic,
            "org.gel.models.participant.avro.Date": participant_1_4_0.Date,
            "org.gel.models.participant.avro.Morphology": participant_1_4_0.Morphology,
            "org.gel.models.participant.avro.TumourPresentation": participant_1_4_0.TumourPresentation,
            "org.gel.models.participant.avro.Topography": participant_1_4_0.Topography,
            "org.gel.models.participant.avro.Topography": participant_1_4_0.Topography,
            "org.gel.models.participant.avro.TumourType": participant_1_4_0.TumourType,
            "org.gel.models.participant.avro.Tumour": participant_1_4_0.Tumour,
        }

    __slots__ = [
        "tumourId",
        "tumourLocalId",
        "tumourType",
        "primaryOrMetastatic",
        "tumourDescription",
        "tumourDiagnosisDate",
        "tumourGrade",
        "tumourMorphologies",
        "tumourParentId",
        "tumourPresentation",
        "tumourPrimaryTopographies",
        "tumourPrognosticScore",
        "tumourStage",
        "tumourTopographies",
    ]

    def __init__(
        self,
        tumourId,
        tumourLocalId,
        tumourType,
        primaryOrMetastatic=None,
        tumourDescription=None,
        tumourDiagnosisDate=None,
        tumourGrade=None,
        tumourMorphologies=None,
        tumourParentId=None,
        tumourPresentation=None,
        tumourPrimaryTopographies=None,
        tumourPrognosticScore=None,
        tumourStage=None,
        tumourTopographies=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_4_0.Tumour model.

        :param tumourId:
            TumourId in GMS
        :type tumourId: str
        :param tumourLocalId:
            Local hospital tumour ID from the GLH Laboratory Information
            Management System (LIMS) in GMS
        :type tumourLocalId: str
        :param tumourType:
            tumourType
        :type tumourType: TumourType
        :param primaryOrMetastatic:
            In GMS, primary or metastatic
        :type primaryOrMetastatic: None | PrimaryOrMetastatic
        :param tumourDescription:
            Description of the tumour
        :type tumourDescription: None | str
        :param tumourDiagnosisDate:
            Date of Diagnosis of the specific tumour
        :type tumourDiagnosisDate: None | Date
        :param tumourGrade:
            Grade of the Tumour
        :type tumourGrade: None | str
        :param tumourMorphologies:
            Morphology of the tumour
        :type tumourMorphologies: None | list[Morphology]
        :param tumourParentId:
            Parent Tumour UID if this tumour is metastatic
        :type tumourParentId: None | str
        :param tumourPresentation:
            In GMS, tumour presentation
        :type tumourPresentation: None | TumourPresentation
        :param tumourPrimaryTopographies:
            Associated primary topography for metastatic tumours
        :type tumourPrimaryTopographies: None | list[Topography]
        :param tumourPrognosticScore:
            Prognostic Score of the Tumour
        :type tumourPrognosticScore: None | str
        :param tumourStage:
            Stage of the Tumour
        :type tumourStage: None | str
        :param tumourTopographies:
            Topography of the tumour
        :type tumourTopographies: None | list[Topography]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.4.0"
